# -*- coding: utf-8 -*-
from setuphelpers import *
import tarfile

bin_path = "/usr/local/bin/soapui"
app_path = "/opt/soapui"

def extract_tar_xz(filename, path="."):
    with tarfile.open(filename, "r:gz") as tar:
        tar.extractall(path)

def install():
    archive_file = glob.glob("*.tar.gz")[0]
    extracted_folder = archive_file.split('-linux-bin', 1)[0]

    # Delete older version
    if isdir(app_path):
        remove_tree(app_path)

    extract_tar_xz(archive_file)
    copytree2(extracted_folder, app_path)

    if isfile(bin_path) or os.path.islink(bin_path):
        print("Removing existing symlink")
        remove_file(bin_path)

    print("Creating soapui alias in path")
    os.symlink(f"{app_path}/bin/soapui.sh", bin_path)

    # Delete extracted folder
    if isdir(extracted_folder):
        remove_tree(extracted_folder)
    

def uninstall():
    # Removing of symlink
    if isfile(bin_path) or os.path.islink(bin_path):
        remove_file(bin_path)
        
    # Removing of the software 
    if isdir(app_path):
        remove_tree(app_path)
