# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
        
    git_repo = "SmartBear/soapui"
    url_api = "https://api.github.com/repos/%s/releases/latest" % git_repo   

    # Getting latest version information from official sources
    print("API used is: %s" % url_api)
    json_load = wgets(url_api, proxies=proxies, as_json=True)

    for line in json_load["body"].split("\r\n"):
        if "SoapUI-" in line and line.endswith(".tar.gz)"):
            download_url = line.split("(")[1].replace(")", "")
            latest_bin = download_url.split("/")[-1]
            version = json_load["tag_name"].replace("v","")
            break

    # Downloading latest binaries
    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    #nettoyer les fichiers temporaires
    for f in glob.glob('*.tar.gz'):
        if f != latest_bin:
            remove_file(f)     
   
    control.set_software_version(version)
    control.impacted_process = f"SoapUI-{version}"
    control.save_control_to_wapt()

    return package_updated